#include <stdio.h>
#include <stdlib.h>
#include "bmk.h"



void print_bmk(bmk_t *B)
{
  bmk_t *P;
  for(P=B->next;P!=B;P=P->next)
  {
    printf("BookmarkBegin\n");
    printf("BookmarkTitle: %s\n",P->title? P->title : "bookmark");
    printf("BookmarkLevel: %d\n", P->level);
    printf("BookmarkPageNumber: %d\n", P->page);
    // printf("%2d [%c] [%6d]: %s\n", P->level, P->type,
    // P->page, P->title ? P->title: "");
    if (P->children)
      print_bmk(P->children);
  }
}

int remove_useless(bmk_t *B, int start, int end)
{
  bmk_t *P,*N;
  if (!B) return 1;
  for(P=B->next;P!=B;P=N)
  {
    N= P->next;
    if (P->type=='B')
    {
      if (P->page>=start && P->page<=end) { P->page-= start-1;  continue; }
    } 
    else if (P->type=='F')
    {
      if (P->page>=start && P->page<=end) { P->page-= start-1; }
      if (!remove_useless(P->children, start, end)) continue;
    }
    P->prev->next= P->next;
    P->next->prev= P->prev;
  }
  return B->next==B;
}


int main(int argc,char **argv)
{
  if (argc!=4) exit(fprintf(stderr,
    "usage: %s input.txt start-page end-page\n", argv[0]));

  bmk_t *top;
  top= bmk_parse(argv[1]);
  if (!top) exit(fprintf(stderr,"can't parse %s\n",argv[1]));

  // print_bmk(top->children);
  remove_useless(top->children, atoi(argv[2]), atoi(argv[3]));
  //printf("REMOVED\n");
  //printf("-----------\n");

  print_bmk(top->children);
  return 0;
}
