
/* The header struct is as follows:
       - Magic
       - Bitmaps Section total size
       - Bitmaps Section offset
       - Graymaps Section total size
       - Graymaps Section offset
       - Pages Section total size
       - Pages Section offset
       - Bookmarks Section total size
       - Bookmarks Section offset  */

#define MAGIC_SIZE 8
unsigned char MAGIC[8]= "IMGDOC01";

#define HDR_BMAP  MAGIC_SIZE
#define HDR_GMAP  (HDR_BMAP+8)
#define HDR_PAGE  (HDR_GMAP+8)
#define HDR_BMK   (HDR_PAGE+8)
#define HDR_TOTAL (HDR_BMK+8)


static unsigned char* optional_compress_commands
      (unsigned char *inp, int *Rinl, int *Routl)
{
  unsigned char *out;
  uLong sz;
  uLong inl;
  out= NULL;

  inl= *Rinl;
  if (inl==0) goto failure;
  sz= compressBound(inl);
  out= malloc(sz);
  if (compress2(out, &sz, inp, inl, Z_BEST_COMPRESSION) || (sz>=inl))
    goto failure;

  *Routl= sz;
  return out;

failure:
  if (out) free(out);
  *Routl= inl;
  *Rinl= 0;
  return inp;
}
